/*
 * JFrameOracle.java
 *
 * Created on 23 de marzo de 2005, 16:20
 */

package learningbom;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowFocusListener;
import java.awt.event.WindowListener;
import javax.swing.JFrame;
import javax.swing.JPanel;

/**
 *
 * @author Alejandro Touza Paredes
 */
public class ConsoleOracleMultiple extends javax.swing.JFrame {
    
    private MyCanvasOracleMultiple com;
    private JFrame jFrameMyCanvasOracleMultiple;
    private JPanel jPanelMyCanvasOracleMultiple;
    private int numPatterns;
    
    /** Crea una nueva instancia de ConsoleOracle */
    public ConsoleOracleMultiple() {
        
        setIconImage(Resources.createImageIcon("/images/icons/IconoProgramaConsolaOracle.gif").getImage());
        initComponents();
        //Repintamos el Canvas cada vez que se gane el foco
        this.addWindowFocusListener(new WindowFocusListener(){
            public void windowLostFocus(WindowEvent evt){}
            public void windowGainedFocus(WindowEvent evt){windowGainedFocusEvent();}
        });
        this.addWindowListener(new WindowListener(){
            public void windowOpened(WindowEvent evt){}
            public void windowIconified(WindowEvent evt){jFrameMyCanvasOracleMultiple.hide();}
            public void windowDeiconified(WindowEvent evt){jFrameMyCanvasOracleMultiple.show(); toFront();}
            public void windowDeactivated(WindowEvent evt){}
            public void windowClosing(WindowEvent evt){doClose();}
            public void windowClosed(WindowEvent evt){}
            public void windowActivated(WindowEvent evt){}
        });
        
        //Lo hacemos as para que en la barra de tareas ConsoleOracle aparezca antes
        //que MyCanvasOracle
        show();
        initMyCanvasOracle();
        jTextFieldPattern.requestFocus();
    }
    private void windowGainedFocusEvent(){
       
       if(com.isStarted())com.repaint();
   }
    private void initMyCanvasOracle(){
        
        jFrameMyCanvasOracleMultiple = new JFrame();
        jFrameMyCanvasOracleMultiple.setIconImage(Resources.createImageIcon("/images/icons/IconoProgramaConsolaOracle32x32.gif").getImage());
        jFrameMyCanvasOracleMultiple.setBounds(this.getX() + this.getWidth(), this.getY(),
                                    SystemScreenSize().width - this.getWidth(), 
                                    SystemScreenSize().height - 30);        
        jFrameMyCanvasOracleMultiple.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
           
        jFrameMyCanvasOracleMultiple.setVisible(true); //necesario para contener al Canvas
        jFrameMyCanvasOracleMultiple.setTitle("Factor Oracle");
        
        JPanel jPanelMyCanvasOracle = new JPanel();
        jPanelMyCanvasOracle = (JPanel)jFrameMyCanvasOracleMultiple.getContentPane();
        
        jPanelMyCanvasOracle.setPreferredSize(jFrameMyCanvasOracleMultiple.getSize());
        jPanelMyCanvasOracle.setLayout(null);
        com = new MyCanvasOracleMultiple(jPanelMyCanvasOracle);
        com.setDrawLink(true);
        
        com.addKeyListener(new KeyListener(){
            public void keyTyped(KeyEvent evt){ }
            public void keyReleased(KeyEvent evt){}
            public void keyPressed(KeyEvent evt){ MyCanvasOracleKeyPressed(evt);}
        });
        jFrameMyCanvasOracleMultiple.addKeyListener(new KeyListener(){
            public void keyTyped(KeyEvent evt){ }
            public void keyReleased(KeyEvent evt){}
            public void keyPressed(KeyEvent evt){ MyCanvasOracleKeyPressed(evt);}
        });
        com.setDefaultListeners(jFrameMyCanvasOracleMultiple, jPanelMyCanvasOracle);
    }
    private void MyCanvasOracleKeyPressed(KeyEvent evt){
   
        switch(evt.getKeyCode())
        {
            case KeyEvent.VK_SPACE:      if(jButtonStep.isEnabled()) doStep();
                                         break;
            case KeyEvent.VK_BACK_SPACE: if(jButtonStepBack.isEnabled()) doStepBack();
                                         break;
            case KeyEvent.VK_ENTER:      if(jButtonComplete.isEnabled()) doComplete();
                                         break;
            case KeyEvent.VK_B:          if(jButtonBOM.isEnabled())
                                         {   
                                            doGotoSBOM();
                                         }
                                         break;                             
            case KeyEvent.VK_R:          if(jButtonReset.isEnabled()) doReset();
                                         break;
            case KeyEvent.VK_S:          doStart();
                                         break;
            case KeyEvent.VK_PLUS:       
            case KeyEvent.VK_ADD:        doBigger();
                                         break;
            case KeyEvent.VK_MINUS:      
            case KeyEvent.VK_SUBTRACT:   doSmaller();
                                         break;
            case KeyEvent.VK_F:          jCheckBoxFitToScreen.doClick();
                                         break;
            case KeyEvent.VK_C:          if(jButtonMoveToStart.isEnabled()) doMoveToStart();
                                         break;
            case KeyEvent.VK_LEFT:       doMove(100, 0);
                                         break;
            case KeyEvent.VK_RIGHT:      doMove(-100, 0);
                                         break;
            case KeyEvent.VK_UP:         doMove(0, 100);
                                         break;
            case KeyEvent.VK_DOWN:       doMove(0, -100);
                                         break;                                 
        }
   } 

    private Dimension SystemScreenSize() {   
        
        return Toolkit.getDefaultToolkit().getScreenSize();
   }  
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanelConsoleOracleMultiple = new javax.swing.JPanel();
        jPanelFactorOracle = new javax.swing.JPanel();
        jTextFieldPattern = new javax.swing.JTextField();
        jTextFieldPatternTwo = new javax.swing.JTextField();
        jTextFieldPatternThree = new javax.swing.JTextField();
        jButtonStart = new javax.swing.JButton();
        jButtonReset = new javax.swing.JButton();
        jPanelSteps = new javax.swing.JPanel();
        jButtonStepBack = new javax.swing.JButton();
        jButtonStep = new javax.swing.JButton();
        jButtonComplete = new javax.swing.JButton();
        jPanelRedrawing = new javax.swing.JPanel();
        jTextFieldSize = new javax.swing.JTextField();
        jButtonResizeOK = new javax.swing.JButton();
        jButtonResizeBigger = new javax.swing.JButton();
        jButtonResizeSmaller = new javax.swing.JButton();
        jCheckBoxFitToScreen = new javax.swing.JCheckBox();
        jButtonMoveToStart = new javax.swing.JButton();
        jPanelHelp = new javax.swing.JPanel();
        jButtonBOM = new javax.swing.JButton();
        jButtonHelp = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridLayout(1, 0));

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Consola Factor Oracle");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setName("JFrameConsole");
        getAccessibleContext().setAccessibleDescription("Consola para Grafos Oracle");
        jPanelConsoleOracleMultiple.setBorder(new javax.swing.border.TitledBorder("Consola"));
        jPanelConsoleOracleMultiple.setMinimumSize(new java.awt.Dimension(40, 0));
        jPanelFactorOracle.setLayout(new java.awt.GridLayout(7, 1));

        jPanelFactorOracle.setBorder(new javax.swing.border.TitledBorder("F.O. Multiple"));
        jPanelFactorOracle.setMaximumSize(getPreferredSize());
        jTextFieldPattern.setText("GTA");
        jTextFieldPattern.setToolTipText("Introduce aqu\u00ed el pattern del Factor Oracle deseado");
        jTextFieldPattern.setMargin(new java.awt.Insets(1, 1, 2, 4));
        jTextFieldPattern.setMaximumSize(new java.awt.Dimension(50, 20));
        jTextFieldPattern.setPreferredSize(new java.awt.Dimension(100, 20));
        jPanelFactorOracle.add(jTextFieldPattern);

        jTextFieldPatternTwo.setText("GCT");
        jTextFieldPatternTwo.setToolTipText("Introduce aqu\u00ed el pattern del Factor Oracle deseado");
        jTextFieldPatternTwo.setMargin(new java.awt.Insets(1, 1, 2, 4));
        jTextFieldPatternTwo.setMaximumSize(new java.awt.Dimension(50, 20));
        jTextFieldPatternTwo.setPreferredSize(new java.awt.Dimension(100, 20));
        jTextFieldPatternTwo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldPatternTwoActionPerformed(evt);
            }
        });

        jPanelFactorOracle.add(jTextFieldPatternTwo);

        jTextFieldPatternThree.setText("GGTTGTA");
        jTextFieldPatternThree.setToolTipText("Introduce aqu\u00ed el pattern del Factor Oracle deseado");
        jTextFieldPatternThree.setMargin(new java.awt.Insets(1, 1, 2, 4));
        jTextFieldPatternThree.setMaximumSize(new java.awt.Dimension(50, 20));
        jTextFieldPatternThree.setPreferredSize(new java.awt.Dimension(100, 20));
        jPanelFactorOracle.add(jTextFieldPatternThree);

        jButtonStart.setText("Empezar");
        jButtonStart.setToolTipText("Comenzar con el Factor Oracle introducido");
        jButtonStart.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jButtonStart.setMaximumSize(getPreferredSize());
        jButtonStart.setMinimumSize(getPreferredSize());
        jButtonStart.setPreferredSize(new java.awt.Dimension(100, 23));
        jButtonStart.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonStartActionPerformed(evt);
            }
        });

        jPanelFactorOracle.add(jButtonStart);

        jButtonReset.setText("Resetear");
        jButtonReset.setToolTipText("Resetear el Factor Oracle actual");
        jButtonReset.setEnabled(false);
        jButtonReset.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jButtonReset.setMaximumSize(getPreferredSize());
        jButtonReset.setMinimumSize(getPreferredSize());
        jButtonReset.setPreferredSize(new java.awt.Dimension(100, 23));
        jButtonReset.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonResetActionPerformed(evt);
            }
        });

        jPanelFactorOracle.add(jButtonReset);

        jPanelSteps.setLayout(new java.awt.GridLayout(1, 0));

        jPanelSteps.setPreferredSize(new java.awt.Dimension(100, 23));
        jButtonStepBack.setText("<<");
        jButtonStepBack.setToolTipText("Retroceder un paso del Factor Oracle");
        jButtonStepBack.setEnabled(false);
        jButtonStepBack.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jButtonStepBack.setMaximumSize(new java.awt.Dimension(50, 23));
        jButtonStepBack.setMinimumSize(new java.awt.Dimension(50, 23));
        jButtonStepBack.setPreferredSize(new java.awt.Dimension(50, 23));
        jButtonStepBack.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonStepBackActionPerformed(evt);
            }
        });

        jPanelSteps.add(jButtonStepBack);

        jButtonStep.setText(">>");
        jButtonStep.setToolTipText("Avanzar un paso del Factor Oracle");
        jButtonStep.setEnabled(false);
        jButtonStep.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jButtonStep.setMaximumSize(new java.awt.Dimension(50, 23));
        jButtonStep.setMinimumSize(getPreferredSize());
        jButtonStep.setPreferredSize(new java.awt.Dimension(50, 23));
        jButtonStep.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonStepActionPerformed(evt);
            }
        });

        jPanelSteps.add(jButtonStep);

        jPanelFactorOracle.add(jPanelSteps);

        jButtonComplete.setText("Completar");
        jButtonComplete.setToolTipText("Completar el Factor Oracle\n");
        jButtonComplete.setEnabled(false);
        jButtonComplete.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jButtonComplete.setMaximumSize(getPreferredSize());
        jButtonComplete.setMinimumSize(getPreferredSize());
        jButtonComplete.setPreferredSize(new java.awt.Dimension(100, 23));
        jButtonComplete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCompleteActionPerformed(evt);
            }
        });

        jPanelFactorOracle.add(jButtonComplete);

        jPanelConsoleOracleMultiple.add(jPanelFactorOracle);

        jPanelRedrawing.setLayout(new java.awt.GridBagLayout());

        jPanelRedrawing.setBorder(new javax.swing.border.TitledBorder("Redibujado"));
        jPanelRedrawing.setMaximumSize(getPreferredSize());
        jTextFieldSize.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldSize.setText("30");
        jTextFieldSize.setToolTipText("Tama\u00f1o de los nodos del FactorOracle");
        jTextFieldSize.setEnabled(false);
        jTextFieldSize.setMaximumSize(getPreferredSize());
        jTextFieldSize.setMinimumSize(getPreferredSize());
        jTextFieldSize.setPreferredSize(new java.awt.Dimension(60, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        jPanelRedrawing.add(jTextFieldSize, gridBagConstraints);

        jButtonResizeOK.setText("OK");
        jButtonResizeOK.setToolTipText("Cambiar el tama\u00f1o de los nodos del FactorOracle indicados por el campo superior");
        jButtonResizeOK.setEnabled(false);
        jButtonResizeOK.setMaximumSize(getPreferredSize());
        jButtonResizeOK.setMinimumSize(getPreferredSize());
        jButtonResizeOK.setPreferredSize(new java.awt.Dimension(60, 23));
        jButtonResizeOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonResizeOKActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        jPanelRedrawing.add(jButtonResizeOK, gridBagConstraints);

        jButtonResizeBigger.setText("+");
        jButtonResizeBigger.setToolTipText("Aumentar en un pixel el tama\u00f1o actual del Factor Oracle");
        jButtonResizeBigger.setEnabled(false);
        jButtonResizeBigger.setMargin(new java.awt.Insets(2, 0, 2, 0));
        jButtonResizeBigger.setMaximumSize(getPreferredSize());
        jButtonResizeBigger.setMinimumSize(getPreferredSize());
        jButtonResizeBigger.setPreferredSize(new java.awt.Dimension(40, 23));
        jButtonResizeBigger.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonResizeBiggerActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        jPanelRedrawing.add(jButtonResizeBigger, gridBagConstraints);

        jButtonResizeSmaller.setText("-");
        jButtonResizeSmaller.setToolTipText("Disminuir en un pixel el tama\u00f1o actual del Factor Oracle");
        jButtonResizeSmaller.setEnabled(false);
        jButtonResizeSmaller.setMargin(new java.awt.Insets(2, 0, 2, 0));
        jButtonResizeSmaller.setMaximumSize(getPreferredSize());
        jButtonResizeSmaller.setMinimumSize(getPreferredSize());
        jButtonResizeSmaller.setPreferredSize(new java.awt.Dimension(40, 23));
        jButtonResizeSmaller.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonResizeSmallerActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        jPanelRedrawing.add(jButtonResizeSmaller, gridBagConstraints);

        jCheckBoxFitToScreen.setSelected(true);
        jCheckBoxFitToScreen.setText("fit to screen");
        jCheckBoxFitToScreen.setToolTipText("Ajusta el tama\u00f1o del Factor Oracle para un mejor visualizado en la ventana actual");
        jCheckBoxFitToScreen.setMinimumSize(getPreferredSize());
        jCheckBoxFitToScreen.setPreferredSize(new java.awt.Dimension(100, 23));
        jCheckBoxFitToScreen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxFitToScreenActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        jPanelRedrawing.add(jCheckBoxFitToScreen, gridBagConstraints);

        jButtonMoveToStart.setText("Centrar");
        jButtonMoveToStart.setToolTipText("Mover el Factor Oracle a la posici\u00f3n inicial");
        jButtonMoveToStart.setEnabled(false);
        jButtonMoveToStart.setMaximumSize(getPreferredSize());
        jButtonMoveToStart.setMinimumSize(getPreferredSize());
        jButtonMoveToStart.setPreferredSize(new java.awt.Dimension(100, 23));
        jButtonMoveToStart.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonMoveToStartActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanelRedrawing.add(jButtonMoveToStart, gridBagConstraints);

        jPanelConsoleOracleMultiple.add(jPanelRedrawing);

        jPanelHelp.setLayout(new java.awt.GridLayout(2, 1));

        jPanelHelp.setMaximumSize(getPreferredSize());
        jButtonBOM.setText("SBOM");
        jButtonBOM.setToolTipText("Realizar una b\u00fasqueda BOM usando el Factor Oracle actual\n");
        jButtonBOM.setEnabled(false);
        jButtonBOM.setMaximumSize(getPreferredSize());
        jButtonBOM.setMinimumSize(getPreferredSize());
        jButtonBOM.setPreferredSize(new java.awt.Dimension(100, 23));
        jButtonBOM.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonBOMActionPerformed(evt);
            }
        });

        jPanelHelp.add(jButtonBOM);

        jButtonHelp.setText("Ayuda");
        jButtonHelp.setToolTipText("Ayuda de los controles de esta Consola");
        jButtonHelp.setMargin(new java.awt.Insets(2, 0, 2, 0));
        jButtonHelp.setMaximumSize(getPreferredSize());
        jButtonHelp.setMinimumSize(getPreferredSize());
        jButtonHelp.setPreferredSize(new java.awt.Dimension(100, 23));
        jPanelHelp.add(jButtonHelp);

        jPanelConsoleOracleMultiple.add(jPanelHelp);

        getContentPane().add(jPanelConsoleOracleMultiple);

        setBounds(0, 0, 136, 459);
    }//GEN-END:initComponents

    private void jTextFieldPatternTwoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldPatternTwoActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextFieldPatternTwoActionPerformed

    private void jButtonBOMActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonBOMActionPerformed
        doGotoSBOM();
    }//GEN-LAST:event_jButtonBOMActionPerformed

    private void jButtonStepBackActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonStepBackActionPerformed
        doStepBack();
    }//GEN-LAST:event_jButtonStepBackActionPerformed
    private void jCheckBoxFitToScreenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxFitToScreenActionPerformed
        doFitToScreen();
    }//GEN-LAST:event_jCheckBoxFitToScreenActionPerformed
    private void jButtonMoveToStartActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonMoveToStartActionPerformed
        doMoveToStart();
    }//GEN-LAST:event_jButtonMoveToStartActionPerformed
    private void jButtonStartActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonStartActionPerformed
        doStart();
    }//GEN-LAST:event_jButtonStartActionPerformed
    private void jButtonCompleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCompleteActionPerformed
        doComplete();
    }//GEN-LAST:event_jButtonCompleteActionPerformed
    private void jButtonResetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonResetActionPerformed
        doReset();
    }//GEN-LAST:event_jButtonResetActionPerformed
    private void jButtonStepActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonStepActionPerformed
        doStep();
    }                                               private void jButtonResizeOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-LAST:event_jButtonStepActionPerformed
        doResize();//GEN-FIRST:event_jButtonResizeOKActionPerformed
    }//GEN-LAST:event_jButtonResizeOKActionPerformed
    private void jButtonResizeBiggerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonResizeBiggerActionPerformed
        doBigger();
    }//GEN-LAST:event_jButtonResizeBiggerActionPerformed
    private void jButtonResizeSmallerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonResizeSmallerActionPerformed
        doSmaller();
    }//GEN-LAST:event_jButtonResizeSmallerActionPerformed
    private void doStart(){
        
        numPatterns = 0;
        //Cogemos el contenido del textfield, lo ponemos en maysculas y comprobamos
        //si est vaco o no. En caso de estarlo no hacemos nada
        if( jTextFieldPattern.getText().length()>0){
            
            String title, pattern, patternTwo, patternThree;
            
            pattern = "";
            patternTwo = "";
            patternThree = "";
            pattern = jTextFieldPattern.getText().toUpperCase();
            jTextFieldPattern.setText(pattern);
            numPatterns++;
            if(jTextFieldPatternTwo.getText().length()>0)
            {
                patternTwo = jTextFieldPatternTwo.getText().toUpperCase();
                jTextFieldPatternTwo.setText(patternTwo);
                numPatterns++;
                if(jTextFieldPatternThree.getText().length()>0)
                {
                    patternThree = jTextFieldPatternThree.getText().toUpperCase();
                    jTextFieldPatternThree.setText(patternThree);
                    numPatterns++;
                }
            }
            if(pattern.length()>30)title = pattern.substring(0, 30); 
            else title = pattern.substring(0, pattern.length());
            title+="... (" + pattern.length() + " caracteres)";
            
            jFrameMyCanvasOracleMultiple.setTitle("F.O.Multiple - " + title);
            
            // Una mejora sera aceptar los patterns estuvieran en el campo
            // en que estuvieran. (revisar)
            System.out.println("numPatterns: " + numPatterns);
            System.out.println("1: " + pattern);
            System.out.println("2: " + patternTwo);
            System.out.println("3: " + patternThree);
            switch(numPatterns)
            {
                case 1: com.start(pattern);
                        break;
                case 2: com.start(pattern, patternTwo);
                        break;
                case 3: com.start(pattern, patternTwo, patternThree);
                        break;
            }
            com.moveToDefaultStartPoint();
            doFitToScreen();
                
            jButtonComplete.setEnabled(true);
            jButtonReset.setEnabled(true);
            jButtonStep.setEnabled(true);
            jButtonStepBack.setEnabled(false);
            jButtonResizeBigger.setEnabled(true);
            jButtonResizeSmaller.setEnabled(true);
            jButtonResizeOK.setEnabled(true);
            jTextFieldSize.setEnabled(true);
            jButtonMoveToStart.setEnabled(true);
            jButtonBOM.setEnabled(true);
            
            com.repaint();
        }
    }
    private void doComplete(){
        
        com.complete();
        jButtonComplete.setEnabled(false);
        jButtonStep.setEnabled(false);
        jButtonStepBack.setEnabled(false);
        if(jCheckBoxFitToScreen.isSelected() && com.isStarted()){
            jTextFieldSize.setText(Integer.toString(com.fitToScreen()));
        }
        com.repaint();
    }
    private void doReset(){
        
        com.reset();
        jButtonComplete.setEnabled(true);
        jButtonStep.setEnabled(true);
        jButtonStepBack.setEnabled(false);
        if(jCheckBoxFitToScreen.isSelected() && com.isStarted()){
            jTextFieldSize.setText(Integer.toString(com.fitToScreen()));
        }
        com.repaint();
    }
    private void doStep(){
        
        //Si hemos realizado el ltimo paso (el Factor Oracle est completo)
        if(com.step()){
            jButtonStep.setEnabled(false);
            jButtonComplete.setEnabled(false);
        }
        else jButtonStepBack.setEnabled(true);
        if(jCheckBoxFitToScreen.isSelected() && com.isStarted()){
            jTextFieldSize.setText(Integer.toString(com.fitToScreen()));
        }
        com.repaint();
    }
    private void doStepBack(){
        
        if(com.stepBack()==0) jButtonStepBack.setEnabled(false);
        jButtonStep.setEnabled(true);
        jButtonComplete.setEnabled(true);
        if(jCheckBoxFitToScreen.isSelected() && com.isStarted()){
            jTextFieldSize.setText(Integer.toString(com.fitToScreen()));
        }
        com.repaint();
    }
    private void doBigger(){
        
        jTextFieldSize.setText(Integer.toString(com.makeItBigger()));
        if(jCheckBoxFitToScreen.isSelected()) jCheckBoxFitToScreen.doClick();
        com.setFitToScreen(false);
        com.repaint();
    }
    private void doSmaller(){
        
        jTextFieldSize.setText(Integer.toString(com.makeItSmaller()));
        if(jCheckBoxFitToScreen.isSelected()) jCheckBoxFitToScreen.doClick();
        com.setFitToScreen(false);
        com.repaint();
    }
    private void doResize(){
        int size=-1;
        try{ //nos aseguramos que lo que haya en el jTextFieldSize sea un entero
            size = Integer.parseInt(jTextFieldSize.getText());
        }catch(NumberFormatException e){}
        if(size>0 && com.isStarted()){
            com.resizeFactorOracle(new Dimension(size, size));
            if(jCheckBoxFitToScreen.isSelected()) jCheckBoxFitToScreen.doClick();
            com.setFitToScreen(false);
            com.repaint();
        }
    }
    private void doFitToScreen(){
        
        //Si no hemos hecho un "Empezar" no hacemos la llamada a fitToScreen()
        if(jCheckBoxFitToScreen.isSelected() && com.isStarted()){
            jTextFieldSize.setText(Integer.toString(com.fitToScreen()));
            com.setFitToScreen(true);
            com.repaint();
        }
        else com.setFitToScreen(false);
    }
    private void doMoveToStart(){
        
        com.moveToDefaultStartPoint();
        com.repaint();
    }
    private void doMove(int x, int y){
        
        if(com.isStarted())
        {
            com.moveFromStartPoint(x, y);
            com.repaint();
        }
    }
    private void doClose(){
            
        jFrameMyCanvasOracleMultiple.dispose();
        dispose();
    }
    private void doGotoSBOM(){
        new ConsoleSBOM(jTextFieldPattern.getText(), 
                        jTextFieldPatternTwo.getText(),
                        jTextFieldPatternThree.getText());
        doClose();
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ConsoleOracle().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonBOM;
    private javax.swing.JButton jButtonComplete;
    private javax.swing.JButton jButtonHelp;
    private javax.swing.JButton jButtonMoveToStart;
    private javax.swing.JButton jButtonReset;
    private javax.swing.JButton jButtonResizeBigger;
    private javax.swing.JButton jButtonResizeOK;
    private javax.swing.JButton jButtonResizeSmaller;
    private javax.swing.JButton jButtonStart;
    private javax.swing.JButton jButtonStep;
    private javax.swing.JButton jButtonStepBack;
    private javax.swing.JCheckBox jCheckBoxFitToScreen;
    private javax.swing.JPanel jPanelConsoleOracleMultiple;
    private javax.swing.JPanel jPanelFactorOracle;
    private javax.swing.JPanel jPanelHelp;
    private javax.swing.JPanel jPanelRedrawing;
    private javax.swing.JPanel jPanelSteps;
    private javax.swing.JTextField jTextFieldPattern;
    private javax.swing.JTextField jTextFieldPatternThree;
    private javax.swing.JTextField jTextFieldPatternTwo;
    private javax.swing.JTextField jTextFieldSize;
    // End of variables declaration//GEN-END:variables
    
}
