/*
 * GraphConst.java
 *
 * Created on 19 de marzo de 2005, 13:05
 */

package oracle;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Point;

/**
 *
 * @author Alejandro Touza Paredes
 */
public abstract interface FactorOracleConst {
  
  // CONSTANTES Node  
    final static int NODE_EMPTY         =-1;
    final static int NODE_NORMAL        = 0;
    final static int NODE_FINAL         = 1;
    final static int NODE_INITIAL       = 2;
    final static int NODE_INITIAL_FINAL = 3;
    final static int NODE_FINAL_SPECIAL = 4;
   
  // CONSTANTES GraphOracle
    final static int STEP_0   = 0;
    final static int STEP_1   = 1;
    final static int STEP_2   = 2;
    final static int STEP_3   = 3;
    final static int STEP_END = 4;
    final static int STEP_0B  = 5;
    final static int STEP_1B  = 6;
    final static int STEP_2B  = 7;
    final static int STEP_3B  = 8;
    
  // CONSTANTES PaintGraph
    //Variables a nivel de Nodo
    final static Dimension NODE_SIZE = new Dimension(30, 30);
    final static int NODE_SEPARATION = Math.max(Math.min((NODE_SIZE.width *7)/8, 100), 25);
    final static float NODE_STROKE   = 0.8f;
    final static Color NODE_BORDER_COLOR                = Color.black;
    final static Color NODE_INSIDE_COLOR                = Color.orange;
    final static Color NODE_FINAL_INSIDE_COLOR          = Color.orange;
    final static Color NODE_FINAL_BORDER_COLOR          = Color.black;
    final static Color NODE_INITIAL_INSIDE_COLOR        = Color.orange;
    final static Color NODE_INITIAL_BORDER_COLOR        = Color.black;
    final static Color NODE_FINAL_SPECIAL_INSIDE_COLOR  = Color.pink;
    final static Color NODE_FINAL_SPECIAL_BORDER_COLOR  = Color.black;
    final static Color NODE_SELECTED_INSIDE_COLOR       = new Color(129,202,156); //Verde claro
    final static Color NODE_SELECTED_BORDER_COLOR       = Color.black;
    final static Color NODE_CURRENT_INSIDE_COLOR        = new Color(153,178,244); //Azul pastel
    final static Color NODE_CURRENT_BORDER_COLOR        = Color.black;
    //Fuentes de Nodo
    final static Font NODE_FONT = new Font("Arial Bold", Font.PLAIN, NODE_SIZE.width / 2);
    final static Color NODE_FONT_COLOR = Color.white;
        
    //Variables a nivel de Transicin
    final static int TRANSITION_HEIGHT_MINIMUM = 18;
    final static int TRANSITION_HEIGHT_MAXIMUM = 30;
    final static int TRANSITION_HEIGHT   = Math.max(Math.min(NODE_SIZE.width/2, 
                                                             TRANSITION_HEIGHT_MAXIMUM), 
                                                    TRANSITION_HEIGHT_MINIMUM);
    final static int TRANSITION_START    = 0;
    final static float TRANSITION_STROKE = 2.3f;
    final static float TRANSITION_ARROW_STROKE = 1.5f;
    
    final static Color TRANSITION_COLOR          = Color.black;
    final static Color TRANSITION_SELECTED_COLOR = Color.green; 
    final static Color TRANSITION_CREATED_COLOR  = Color.red;
    //Fuentes de Transicin
    final static Font TRANSITION_FONT = 
                 new Font("Arial Bold", Font.PLAIN, Math.max(TRANSITION_HEIGHT * 4/5, 8));
    final static Color TRANSITION_FONT_COLOR = Color.black;
    final static int TRANSITION_ARROW_SIZE = Math.min(NODE_SIZE.width / 4, 6);
    
    //Variables a nivel de Grafo
    final static Point AUTOMATON_START_POINT = new Point(0,0);
    final static Color AUTOMATON_BACKGROUND_COLOR = Color.lightGray;
    
    //Fuentes de Pattern
    final static Font  PATTERN_FONT = new Font("Arial Bold", Font.PLAIN, 25);
    final static Color PATTERN_FONT_COLOR          = Color.white;
    final static Color PATTERN_FONT_SELECTED_COLOR = Color.black;
   
    //Fuentes de Tag
    final static Font  TAG_FONT = new Font("Arial Bold", Font.PLAIN, 12);
    final static Color TAG_FONT_COLOR          = Color.black;
    final static Color TAG_COLOR               = Color.yellow;
    
  // CONSTANTES PaintGraphOracle    
    //Suffix Link (PaintGraphBOM)
    final static int LINK_HEIGHT   = TRANSITION_HEIGHT;
    final static int LINK_START    = TRANSITION_START;
    final static float LINK_STROKE = 2.3f;
    final static Color LINK_COLOR          = Color.blue;
    final static Color LINK_SELECTED_COLOR = Color.green;
    final static Color LINK_CREATED_COLOR  = Color.red;
    
    
    
}
